# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *
from .file import File
import pulumi_command

__all__ = ['ContainerdConfigurationArgs', 'ContainerdConfiguration']

@pulumi.input_type
class ContainerdConfigurationArgs:
    def __init__(__self__, *,
                 connection: pulumi.Input['pulumi_command.remote.ConnectionArgs'],
                 cri: Optional['ContainerdCriPluginConfigurationArgs'] = None,
                 path: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a ContainerdConfiguration resource.
        :param pulumi.Input['pulumi_command.remote.ConnectionArgs'] connection: The parameters with which to connect to the remote host.
        :param 'ContainerdCriPluginConfigurationArgs' cri: The cri configuration.
        :param pulumi.Input[str] path: The path to put the configuration file.
        """
        pulumi.set(__self__, "connection", connection)
        if cri is not None:
            pulumi.set(__self__, "cri", cri)
        if path is not None:
            pulumi.set(__self__, "path", path)

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Input['pulumi_command.remote.ConnectionArgs']:
        """
        The parameters with which to connect to the remote host.
        """
        return pulumi.get(self, "connection")

    @connection.setter
    def connection(self, value: pulumi.Input['pulumi_command.remote.ConnectionArgs']):
        pulumi.set(self, "connection", value)

    @property
    @pulumi.getter
    def cri(self) -> Optional['ContainerdCriPluginConfigurationArgs']:
        """
        The cri configuration.
        """
        return pulumi.get(self, "cri")

    @cri.setter
    def cri(self, value: Optional['ContainerdCriPluginConfigurationArgs']):
        pulumi.set(self, "cri", value)

    @property
    @pulumi.getter
    def path(self) -> Optional[pulumi.Input[str]]:
        """
        The path to put the configuration file.
        """
        return pulumi.get(self, "path")

    @path.setter
    def path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "path", value)


class ContainerdConfiguration(pulumi.ComponentResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 connection: Optional[pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']]] = None,
                 cri: Optional[pulumi.InputType['ContainerdCriPluginConfigurationArgs']] = None,
                 path: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        The containerd configuration file.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']] connection: The parameters with which to connect to the remote host.
        :param pulumi.InputType['ContainerdCriPluginConfigurationArgs'] cri: The cri configuration.
        :param pulumi.Input[str] path: The path to put the configuration file.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ContainerdConfigurationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The containerd configuration file.

        :param str resource_name: The name of the resource.
        :param ContainerdConfigurationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ContainerdConfigurationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 connection: Optional[pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']]] = None,
                 cri: Optional[pulumi.InputType['ContainerdCriPluginConfigurationArgs']] = None,
                 path: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is not None:
            raise ValueError('ComponentResource classes do not support opts.id')
        else:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ContainerdConfigurationArgs.__new__(ContainerdConfigurationArgs)

            if connection is None and not opts.urn:
                raise TypeError("Missing required property 'connection'")
            __props__.__dict__["connection"] = connection
            __props__.__dict__["cri"] = cri
            __props__.__dict__["path"] = path
            __props__.__dict__["file"] = None
        super(ContainerdConfiguration, __self__).__init__(
            'kubernetes-the-hard-way:remote:ContainerdConfiguration',
            resource_name,
            __props__,
            opts,
            remote=True)

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Output['pulumi_command.remote.outputs.Connection']:
        """
        The parameters with which to connect to the remote host.
        """
        return pulumi.get(self, "connection")

    @property
    @pulumi.getter
    def cri(self) -> pulumi.Output['outputs.ContainerdCriPluginConfiguration']:
        """
        The cri configuration.
        """
        return pulumi.get(self, "cri")

    @property
    @pulumi.getter
    def file(self) -> pulumi.Output['File']:
        """
        The remote configuration file.
        """
        return pulumi.get(self, "file")

    @property
    @pulumi.getter
    def path(self) -> pulumi.Output[Optional[str]]:
        """
        The path to put the configuration file.
        """
        return pulumi.get(self, "path")

